#include <stdio.h>
#include <string.h>
#include <ao/ao.h>
#include <unistd.h>
#include <math.h>
#define BUF_SIZE 8192


int main(int argc, char **argv)
{
	ao_device *device;
	ao_sample_format format;
	int default_driver;
	char *buffer;
	int buf_size;
	int sample;
	float freq = 440.0;
	int i;

	/* -- Initialize -- */

	fprintf(stderr, "libao example program\n");

	ao_initialize();

	/* -- Setup for default driver -- */

	default_driver = ao_default_driver_id();

        memset(&format, 0, sizeof(format));
	format.bits = 16;
	format.channels = 2;
	format.rate = 44100;
  format.byte_format = AO_FMT_NATIVE;

	/* -- Open driver -- */
	device = ao_open_live(default_driver, &format, NULL /* no options */);
	if (device == NULL) {
		fprintf(stderr, "Error opening device.\n");
		return 1;
	}

	/* -- Play some stuff -- */
	buf_size = format.bits/8 * format.channels * format.rate;
	buffer = calloc(buf_size, sizeof(char));

  for(i = 0; i < format.rate; i++)
  {
    //buffer[i]=((float)rand()/(float)(RAND_MAX/1)) * 2.0 - 1.0;
    //buffer[i]=(char)sin(5);
    char sample = (int)(0.1 * 64.0 *
                   sin(25 * M_PI * freq * ((float) i/format.rate)));
    buffer[i] = sample;
  }
  

  while(1)
  {
    ao_play(device, buffer, buf_size);
    sleep(5);
  }
	/* -- Close and shutdown -- */
	ao_close(device);

	ao_shutdown();

  return (0);
}
